import time
import pandas as pd
import numpy as np
import input_ms as im
from selenium import webdriver
from selenium.webdriver import Edge
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from PIL import Image
from chaojiying import Chaojiying_Client



frame = pd.read_excel(im.path,sheet_name='东财交易') # 读取excel表
frame = np.array(frame,dtype=str)   # 将数据转化为numpy,利于数据处理
length = len(frame)     # 读取行数

web = Edge()
web.get('https://jywg.18.cn/Trade/Buy')     # 打开东财
# 浏览器巨大化
# web.maximize_window()

web.find_element(By.ID, "txtZjzh").send_keys(im.dczh)    # 利用id获取输入框，利用send_keys输入东财账号
web.find_element(By.ID, "txtPwd").send_keys(im.dcmm)   # 利用id获取输入框，利用send_keys输入东财密码
res = web.find_element(By.ID, "imgValidCode")   # 获取验证码图片的元素
png_path = 'login.png'  # 保存文件路径
with open(png_path, 'wb') as file:
    file.write(res.screenshot_as_png)   # 保存图片

# 超级鹰验证码识别https://www.chaojiying.com/user/
cjy = Chaojiying_Client(im.cjy_zh, im.cjy_mm, im.cjy_id)  # 用户中心>>软件ID 生成一个替换 96001
im = open('login.png', 'rb').read()  # 本地图片文件路径 来替换 a.jpg 有时WIN系统须要//
res = cjy.PostPic(im, 1902)  # 1902 验证码类型  官方网站>>价格体系 3.4+版 print 后要加()
data = res['pic_str']
time.sleep(1)
web.find_element(By.ID,'txtValidCode').send_keys(data)  # 填入验证码
time.sleep(1)
web.find_element(By.ID,'rdsc45').click()    # 点击在线时间
web.find_element(By.ID,'btnConfirm').click()    # 点击登录
time.sleep(1)


Buy = "//*[@id='main']/div/div[2]/div[1]/ul/li[2]/a"
Sell = "//*[@id='main']/div/div[2]/div[1]/ul/li[3]/a"
def main_func(BS):
    web.find_element(By.XPATH,BS).click()  # 引入买卖
    time.sleep(0.5)
    web.find_element(By.ID,'btnReset').click()  # 点击清空数据
    time.sleep(0.5)
    web.find_element(By.ID,'stockCode').send_keys(frame[i, 1])  # 输入代码
    time.sleep(0.5)
    web.find_element(By.ID,'iptPrice').click()  # 点击价格
    time.sleep(0.5)
    web.find_element(By.ID,'iptPrice').clear()   # 清空默认输入的现价
    time.sleep(0.5)
    web.find_element(By.ID,'iptPrice').send_keys(frame[i, 3])   # 输入价格
    time.sleep(0.5)
    web.find_element(By.ID,'iptCount').click()  # 点击数量
    time.sleep(0.5)
    web.find_element(By.ID,'iptCount').clear()   # 清空默认输入的数量
    time.sleep(0.5)
    web.find_element(By.ID,'iptCount').send_keys(frame[i, 2])   # 输入数量
    time.sleep(0.5)
    web.find_element(By.ID,'btnConfirm').click()    # 点击操作
    time.sleep(0.5)
    web.find_element(By.XPATH,'/html/body/table/tbody/tr[2]/td[2]/div/div[1]/div[2]/a[1]').click()  # 确认交易
    time.sleep(0.5)
    web.find_element(By.ID,'btnCxcConfirm').click()     # 提醒返回
    time.sleep(0.5)

# 判断交易
for i in range(length):
    if frame[i, 0] == 'B':
        main_func(Buy)
    elif frame[i, 0] == 'S':
        main_func(Sell)
    else:
        print()
time.sleep(10)

web.quit()